#include"h7.h"
#include<string.h>
using namespace std;


//构造函数
String::String()
{
	s=NULL;
}

String::String(const char* sx)
{
	//if(s)
		//delete [] s;
	s=new char[strlen(sx)+1];
	strcpy(s,sx);
}

String::String(char sx)
{
	s[0]=sx;
}

String::String(int sx)
{
	s[0]=char(sx);
}

String::String(const String& temp)
{
	//if(s)
		//delete [] s;
	s=new char[strlen(temp.s)+1];
	strcpy(s,temp.s);
}

String::String(double sx)
{
	s[0]=char(sx);
}

String::~String()
{
	delete [] s;
}



//public方法

String String::operator+(const String& temp)
{
	String str;
	str.s=new char[strlen(s)+strlen(temp.s)+1];
	strcpy(str.s,s);
	strcat(str.s,temp.s);
	return str;
}

String String::operator-(String& temp)
{
	String str;
	char* p;
	int i=0,j=0,firstlong=strlen(s),secondlong=strlen(temp.s);
	if(strlen(s)>strlen(temp.s))
	{
		str.s=new char[strlen(s)+1];
		p=str.s;
	}
	else
	{
		str.s=new char[strlen(temp.s)+1];
		p=str.s;
	}	
	while(i<firstlong&&j<secondlong)
	{
		if(*s<*temp.s)
		{
			*p=*s;
			s++;
			temp.s++;
			p++;
			i++;
			j++;
		}
		else
		{
			*p=*temp.s;
			temp.s++;
			s++;
			p++;
			i++;
			j++;
		}
	}
	while(i<firstlong)
	{
		strcat(p,s);
		break;
	}
	while(j<secondlong)
	{
		strcat(p,temp.s);
		break;
	}
	return str;
}
String& String::operator=(const String& temp)
{
	if(this==&temp)
		return *this;
	if(s)
		delete [] s;
	s=new char[strlen(temp.s)+1];
	strcpy(s,temp.s);
	return *this;
}

int String::Strcmph(String& temp)
{
	return strcmp(s,temp.s);
}

int String::Strlenh()
{
	return strlen(s);
}	

String String::Strcath(String& temp)
{
	String str;
	str.s=new char[strlen(s)+strlen(temp.s)+1];
	strcpy(str.s,s);
	strcat(str.s,temp.s);
}

void String::deleteSpace()
{
	for(int i=0;i<strlen(s);++i)
	{
		char* p=s;
		if(*s==' ')	
		{
			while(*p)
			{	
				*p=*(p+1);
				p++;
			}
		}
		else
			return;
	}
}

void String::BigWrite()
{
	char* p=s;	
	while(*p>='a'&&*p<'z')
	{
		*p-=32;
		p++;
	}
}

void String::LittleWrite()
{
	char* p=s;	
	while(*p>='A'&&*p<'Z')
	{
		*p+=32;
		p++;
	}
}

String::operator double()
{
	return double(*s);
}

String::operator int()
{
	return int(*s);
}

ostream& operator<<(ostream& out,String& temp)
{
	out<<"The Strings are  "<<"'"<<temp.s<<"' ";
	return out;
}

istream& operator>>(istream& in,String& temp)
{
	cout<<"Please input Dates of 'class String' :"<<endl;
	in>>temp.s;
}



