#ifndef h7_h
#define h7_h
#include<iostream>
using namespace std;

class String
{
private:
	char* s;
public:
	String();
	String(const char* sx);
	String(char sx);
	String(int sx);
	String(const String& );
	String(double sx);
	~String();
	String operator+(const String& );				//加法，减法
	String operator-(String& ); 
	String& operator=(const String& );			//赋值
	int Strcmph(String& temp);							//比较大小
	int Strlenh();							//计算长度
	String Strcath(String& );					//  连接字符
	void deleteSpace();					 //删除空格
	void BigWrite();				//转换大写
	void LittleWrite();		//转换小写
	operator double();
	operator int();					//转换整形，或者浮点
	friend ostream& operator<<(ostream& out,String& temp);
	friend istream& operator>>(istream& in,String& temp);				 //输入输出
};
#endif
